
//////////////////////////////////////////////////////////////////////
// ArcManMS2.h: CArcManMS2 NX̃C^[tFCX
//				͂MS-Compress `̈kE𓀂sB
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_ARCMANMS2_H__E681A500_B3CD_11D3_8D96_8F94262F172D__INCLUDED_)
#define AFX_ARCMANMS2_H__E681A500_B3CD_11D3_8D96_8F94262F172D__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "ArcMan.h"

class CArcManMS2 : public CArcMan
{
public:
	CArcManMS2(){m_Types[0]="MS-Compress(??_)";m_nType++;};
	virtual ~CArcManMS2(){};
	void VersionString( CKString& VerStr );

	bool CanMelt( const char* fname );
	bool CanCompress( CKString& Type ){return (Type==m_Types[0]);};

	bool Melt( CKString& File,CKString* pPath,bool bMDir,bool bNoDDir );
	bool Compress( CKString& Type,CFileList& Files,CKString& Path,CKString* pResult=NULL );

private:
	bool WriteHeader( FILE* fp );
	void CompressMain( FILE* in,FILE* out );

	bool ReadHeader( FILE* fp );
	void MeltMain( FILE* in,FILE* out );

	short lenLV,stkLV;
	char m_Ext3;
	unsigned long m_Length;

	static DWORD WINAPI ThreadFunc(void * p);
	static BOOL CALLBACK DlgFunc( HWND dlg, UINT msg, WPARAM wp, LPARAM lp );
	volatile HWND m_hDlg;
	volatile unsigned long m_DlgParam;
};

#endif // !defined(AFX_ARCMANMS2_H__E681A500_B3CD_11D3_8D96_8F94262F172D__INCLUDED_)
